unit Skladba;

// tato unita obsahuje definice trid souvisejicich s notovym zaznamem

interface

type
        TNota = class(TObject)
                Delka : real; // pro zmateni je zde cela cast
                Pomlka : boolean; // jde o notu nebo pomlku?
                Vyska : integer;
                Cis : boolean;

                function JeCis : string;
                function SmerNozicky : string;
                function Posun : integer;

        end;

        TSkladba = class(TObject)
                Takt : integer; // 3 = 3/4, 4 = 4/4, 5 = 5/4
                PocetNot : integer; // doufejme ze cca 32 tisic not nedosahne ani skladatelsky grafoman
                Noty : array of TNota; // dynamicke pole not

                function NastavTakt(fTakt : string) : boolean;
                function PridejNotu(fPomlka : boolean; fDelka : string; fVyska : string) : boolean;
        end;

implementation

uses SysUtils;

function TSkladba.NastavTakt(fTakt : string) : boolean;
begin
        Result := true;
        if fTakt = '3/4' then Takt := 3
        else if fTakt = '4/4' then Takt := 4
        else if fTakt = '5/4' then Takt := 5
        else Result := false;
end;

function TSkladba.PridejNotu(fPomlka : boolean; fDelka, fVyska : string) : boolean;
var lDelka : real; lVyska : integer; lCis : boolean;
begin
        Result := true;
        lCis := false;
        lDelka := StrToFloat(fDelka);
        // prevedeme hodnotu noty
        if not fPomlka then
        if fVyska = 'C' then begin
                lVyska := 0;
        end else if fVyska = 'Cis' then begin
                lVyska := 0;
                lCis := true;
        end else if fVyska = 'D' then begin
                lVyska := 1;
        end else if fVyska = 'Dis' then begin
                lVyska := 1;
                lCis := true;
        end else if fVyska = 'E' then begin
                lVyska := 2;
        end else if fVyska = 'F' then begin
                lVyska := 3;
        end else if fVyska = 'Fis' then begin
                lVyska := 3;
                lCis := true;
        end else if fVyska = 'G' then begin
                lVyska := 4;
        end else if fVyska = 'Gis' then begin
                lVyska := 4;
                lCis := true;
        end else if fVyska = 'A' then begin
                lVyska := 5;
        end else if fVyska = 'Ais' then begin
                lVyska := 5;
                lCis := true;
        end else if fVyska = 'H' then begin
                lVyska := 6;
        end else if fVyska = 'c' then begin
                lVyska := 7;
        end else if fVyska = 'cis' then begin
                lVyska := 7;
                lCis := true;
        end else if fVyska = 'd' then begin
                lVyska := 8;
        end else if fVyska = 'dis' then begin
                lVyska := 8;
                lCis := true;
        end else if fVyska = 'e' then begin
                lVyska := 9;
        end else if fVyska = 'f' then begin
                lVyska := 10;
        end else if fVyska = 'fis' then begin
                lVyska := 10;
                lCis := true;
        end else if fVyska = 'g' then begin
                lVyska := 11;
        end else if fVyska = 'gis' then begin
                lVyska := 11;
                lCis := true;
        end else if fVyska = 'a' then begin
                lVyska := 12;
        end else if fVyska = 'ais' then begin
                lVyska := 12;
                lCis := true;
        end else if fVyska = 'h' then begin
                lVyska := 13;
        end else begin
                // neznamy ton
                Result := false;
                Exit;
        end;
        SetLength(Noty, PocetNot+1);
        Noty[PocetNot] := TNota.Create;
        Noty[PocetNot].Pomlka := fPomlka;
        Noty[PocetNot].Delka := lDelka;
        Noty[PocetNot].Vyska := lVyska;
        Noty[PocetNot].Cis := lCis;
        PocetNot := PocetNot + 1;
end;

function TNota.JeCis : string;
begin
  if Cis then result := '_krizek' else result := '';
end;

function TNota.SmerNozicky : string;
begin
  if Vyska > 6 then result := 'dolu_' else result := 'nahoru_';
end;

function TNota.Posun : integer;
begin
  result := 0;
  if Vyska <7 then result := -23;
  if Cis and (Vyska > 7) then result := -7;
end;

end.
