unit SkladbaEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, xmldom, XMLIntf, msxmldom, XMLDoc, Skladba;

type
  TfrmSkladba = class(TForm)
    imgSkladba: TImage;
    srlSkladba: TScrollBar;
    xmlSkladba: TXMLDocument;
    procedure FormCreate(Sender: TObject);
    procedure srlSkladbaChange(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Skladba : TSkladba;
    function NahrajSkladbu(fNazev : string) : boolean;
    function Vykresli(fObraz : string; fX, fY : integer) : integer;
    function VykresliNoticku(fDelka : integer; fNoticka : TNota; fPozice : integer) : integer;
    function VykresliPauzicku(fDelka : integer; fNoticka : TNota; fPozice : integer) : integer;
    procedure PrekresliNoticky();
  end;

var
  frmSkladba: TfrmSkladba;

implementation

uses MainForm;

{$R *.dfm}

function TfrmSkladba.NahrajSkladbu(fNazev : string) : boolean;
var Vnitrek : IXMLNodeList;
        Textik : string;
        i : integer;
begin
        Result := true;
        // nahrajeme soubor
        //xmlSkladba.FileName := fNazev;
        xmlSkladba.LoadFromFile(fNazev);
        Vnitrek := xmlSkladba.ChildNodes;
        Skladba := TSkladba.Create;
        if not Skladba.NastavTakt(Vnitrek.Nodes[0].Attributes['takt']) then begin
                Result := false; // neco se nepovidlo
                Close;
                Exit;
        end;
        Vnitrek := Vnitrek.Nodes[0].ChildNodes;
        // pojedeme hezky cyklusem a pridame noticky
        for i := 0 to Vnitrek.Count - 1 do begin
                Textik := Vnitrek.Nodes[i].NodeName;
                if Vnitrek.Nodes[i].NodeType = ntElement then
                        if Vnitrek.Nodes[i].NodeName = 'pomlka' then begin
                                if not Skladba.PridejNotu(true, Vnitrek.Nodes[i].Attributes['delka'], '') then begin
                                        Result := false; // neco se nepovidlo
                                        Close;
                                        Exit;
                                end;
                        end else
                                if not Skladba.PridejNotu(false, Vnitrek.Nodes[i].Attributes['delka'], Vnitrek.Nodes[i].Attributes['vyska']) then begin
                                        Result := false; // neco se nepovidlo
                                        Close;
                                        Exit;
                                end;
        end;
        // dame vykreslit
        Caption := fNazev;
        dec(CitacOken);
        FormResize(nil);
end;

procedure TfrmSkladba.FormCreate(Sender: TObject);
begin
        // uprav svj nadpis s ohledem na ta
        inc(CitacOken);
        Caption := Caption + ' ' + IntToStr(CitacOken);
end;

procedure TfrmSkladba.srlSkladbaChange(Sender: TObject);
begin
        // posune se v notove osnove
        // tim padem dojde ke zmene zobrazeni
        // prekreslime tedy notovy zaznam od noveho indexu
        PrekresliNoticky;
end;

function TfrmSkladba.Vykresli(fObraz : string; fX, fY : integer) : integer;
var lSoubor : textfile; lTmp : string; i,j : byte;
begin
        // nacte soubor
        AssignFile(lSoubor, ExtractFileDir(ParamStr(0))+'/grafika/'+fObraz+'.txt');
        Reset(lSoubor);
        // preskocime prvni radek, je uplne zbytecny
        Readln(lSoubor, lTmp);
        // kreslime
        j := 0;
        while not eof(lSoubor) do begin
                Readln(lSoubor, lTmp);
                for i := 1 to Length(lTmp) do begin
                        if lTmp[i] = '@' then imgSkladba.Canvas.Pixels[fX+i,fY+j] := 0;
                end;
                inc(j);
        end;
        Result := Length(lTmp);
        CloseFile(lSoubor);
end;

function TfrmSkladba.VykresliNoticku(fDelka : integer; fNoticka : TNota; fPozice : integer) : integer;
begin
        // jak jednotlive delky rozdelime?
        // idealni bude proste z hlavy si pripravit tabulku, cokoliv jineho by bylo zbytecne slozite
        // ono by to sice slo pres binarni soustavu, ale z te nevymlatim jednoduchym zpusobem noty s teckami
        case fDelka of
        0:      ; // nedelame nic
        1:      fPozice := fPozice + Vykresli('nota_'+fNoticka.JeCis+fNoticka.SmerNozicky+'0',fPozice,fNoticka.Posun+55-fNoticka.Vyska*4) + 4;// 1 osminova nota
        2:      fPozice := fPozice + Vykresli('nota_'+fNoticka.JeCis+fNoticka.SmerNozicky+'1',fPozice,fNoticka.Posun+55-fNoticka.Vyska*4) + 4;// 1 ctrvtova nota
        3:      begin
                        fPozice := fPozice + Vykresli('nota_'+fNoticka.JeCis+fNoticka.SmerNozicky+'0',fPozice,fNoticka.Posun+55-fNoticka.Vyska*4) + 4; // 1 ctvrtova prodlouzena
                        fPozice := fPozice + Vykresli('tecka',fPozice,55-fNoticka.Vyska*4) + 4;
                end;
        4:      fPozice := fPozice + Vykresli('nota_'+fNoticka.JeCis+fNoticka.SmerNozicky+'2',fPozice,fNoticka.Posun+55-fNoticka.Vyska*4) + 4;// 1 pulova nota\
        5:      begin
                        fPozice := fPozice + Vykresli('nota_'+fNoticka.JeCis+fNoticka.SmerNozicky+'2',fPozice,fNoticka.Posun+fNoticka.Posun+55-fNoticka.Vyska*4) + 4; // 1 pulova a 1 osminova
                        fPozice := fPozice + Vykresli('nota_'+fNoticka.JeCis+fNoticka.SmerNozicky+'0',fPozice,fNoticka.Posun+55-fNoticka.Vyska*4) + 4;
                end;
        6:      begin
                        fPozice := fPozice + Vykresli('nota_'+fNoticka.JeCis+fNoticka.SmerNozicky+'1',fPozice,fNoticka.Posun+55-fNoticka.Vyska*4) + 4; // 1 ctvrtova prodlouzena
                        fPozice := fPozice + Vykresli('tecka',fPozice,55-fNoticka.Vyska*4) + 4;
                end;
        7:      begin
                        fPozice := fPozice + Vykresli('nota_'+fNoticka.JeCis+fNoticka.SmerNozicky+'2',fPozice,fNoticka.Posun+55-fNoticka.Vyska*4) + 4;// 1 pulova nota
                        fPozice := fPozice + Vykresli('nota_'+fNoticka.JeCis+fNoticka.SmerNozicky+'0',fPozice,fNoticka.Posun+55-fNoticka.Vyska*4) + 4; // 1 ctvrtova prodlouzena
                        fPozice := fPozice + Vykresli('tecka',fPozice,55-fNoticka.Vyska*4) + 4;
                end;
        8:      fPozice := fPozice + Vykresli('nota_'+fNoticka.JeCis+'4',fPozice,55-fNoticka.Vyska*4) + 4; // 1 cela
        9:      begin
                        fPozice := fPozice + Vykresli('nota_'+fNoticka.JeCis+fNoticka.SmerNozicky+'2',fPozice,fNoticka.Posun+55-fNoticka.Vyska*4) + 4;// 1 pulova nota
                        fPozice := fPozice + Vykresli('nota_'+fNoticka.JeCis+fNoticka.SmerNozicky+'2',fPozice,fNoticka.Posun+55-fNoticka.Vyska*4) + 4; // 1 pulova a 1 osminova
                        fPozice := fPozice + Vykresli('nota_'+fNoticka.JeCis+fNoticka.SmerNozicky+'0',fPozice,fNoticka.Posun+55-fNoticka.Vyska*4) + 4;
                end;
        10:     begin
                        fPozice := fPozice + Vykresli('nota_'+fNoticka.JeCis+'4',fPozice,55-fNoticka.Vyska*4) + 4; // 1 cela
                        fPozice := fPozice + Vykresli('nota_'+fNoticka.JeCis+fNoticka.SmerNozicky+'1',fPozice,fNoticka.Posun+55-fNoticka.Vyska*4) + 4; // 1 ctvrtova
                end;
        end;
        Result := fPozice;
end;

function TfrmSkladba.VykresliPauzicku(fDelka : integer; fNoticka : TNota; fPozice : integer) : integer;
begin
        // jak jednotlive delky rozdelime?
        // idealni bude proste z hlavy si pripravit tabulku, cokoliv jineho by bylo zbytecne slozite
        // ono by to sice slo pres binarni soustavu, ale z te nevymlatim jednoduchym zpusobem noty s teckami
        case fDelka of
        0:      ; // nedelame nic
        1:      fPozice := fPozice + Vykresli('pomlka_0',fPozice,22) + 4;// 1 osminova nota
        2:      fPozice := fPozice + Vykresli('pomlka_1',fPozice,22) + 4;// 1 ctrvtova nota
        3:      begin
                        fPozice := fPozice + Vykresli('pomlka_0',fPozice,22) + 4; // 1 ctvrtova prodlouzena
                        fPozice := fPozice + Vykresli('tecka',fPozice,22) + 4;
                end;
        4:      fPozice := fPozice + Vykresli('pomlka_2',fPozice,22) + 4;// 1 pulova nota\
        5:      begin
                        fPozice := fPozice + Vykresli('pomlka_2',fPozice,22) + 4; // 1 pulova a 1 osminova
                        fPozice := fPozice + Vykresli('pomlka_0',fPozice,22) + 4;
                end;
        6:      begin
                        fPozice := fPozice + Vykresli('pomlka_1',fPozice,22) + 4; // 1 ctvrtova prodlouzena
                        fPozice := fPozice + Vykresli('tecka',fPozice,22) + 4;
                end;
        7:      begin
                        fPozice := fPozice + Vykresli('pomlka_2',fPozice,22) + 4;// 1 pulova nota
                        fPozice := fPozice + Vykresli('pomlka_0',fPozice,22) + 4; // 1 ctvrtova prodlouzena
                        fPozice := fPozice + Vykresli('tecka',fPozice,22) + 4;
                end;
        8:      fPozice := fPozice + Vykresli('pomlka_4',fPozice,22) + 4; // 1 cela
        9:      begin
                        fPozice := fPozice + Vykresli('pomlka_2',fPozice,22) + 4;// 1 pulova nota
                        fPozice := fPozice + Vykresli('pomlka_2',fPozice,22) + 4; // 1 pulova a 1 osminova
                        fPozice := fPozice + Vykresli('pomlka_0',fPozice,22) + 4;
                end;
        10:     begin
                        fPozice := fPozice + Vykresli('pomlka_4',fPozice,22) + 4; // 1 cela
                        fPozice := fPozice + Vykresli('pomlka_1',fPozice,22) + 4; // 1 ctvrtova
                end;
        end;
        Result := fPozice;
end;

procedure TfrmSkladba.PrekresliNoticky;
var i : integer; pozice : integer; doba, dobastara : integer; notacislo : char;
begin
        // nakreslime po cele delce notove linky
        // linky jsou od sebe 8 pixelu a je jich 5
        imgSkladba.Picture := nil; // vymazeme
        for i := 0 to 4 do begin
           imgSkladba.Canvas.MoveTo(0,20+8*i);
           imgSkladba.Canvas.LineTo(imgSkladba.Width, 20+8*i);
        end;
        // vykreslime textovou grafiku, ktera je v adresari '/grafika'
        Pozice := 0;
        Doba := 0;
        for i := -2 to srlSkladba.Max do begin
                if i >= Skladba.PocetNot then exit;
                // zacneme klicem, pokud je pozice -2
                if i = -2 then begin
                        if i >= srlSkladba.Position then Pozice := Pozice + Vykresli('klic',Pozice,1) + 4;
                end
                // pote nakreslime takt skladby
                else if i = -1 then begin
                        if i >= srlSkladba.Position then Pozice := Pozice + Vykresli('takt_'+IntToStr(Skladba.Takt),Pozice,22) + 4;
                end
                else begin
                        // kreslime noticky
                        DobaStara := Doba;
                        Doba := Doba + trunc(2*Skladba.Noty[i].Delka);
                        while Doba >= 2*Skladba.Takt do begin
                                // tuto notu budeme muset rozdelit
                                // Doba - 2*Skladba.Takt urcuje spotrebovany cas za |
                                // 2*Skladba.Takt - (Doba - trunc(2*Skladba.Noty[i].Delka))
                                if i >= srlSkladba.Position then begin
                                if Skladba.Noty[i].Pomlka then begin
                                        Pozice := VykresliPauzicku(2*Skladba.Takt - DobaStara,Skladba.Noty[i], Pozice)
                                end else begin
                                        Pozice := VykresliNoticku(2*Skladba.Takt - DobaStara,Skladba.Noty[i], Pozice);
                                        end;
                                end;
                                Doba := Doba - 2*Skladba.Takt;
                                DobaStara := 0;
                                // nakreslime svislou caru
                                if i >= srlSkladba.Position then
                                Pozice := Pozice + Vykresli('doba',Pozice+2,20) + 8;
                        end;
                        if i >= srlSkladba.Position then begin
                        if Skladba.Noty[i].Pomlka then
                                Pozice := VykresliPauzicku(2*Skladba.Takt - DobaStara,Skladba.Noty[i], Pozice)
                        else
                                Pozice := VykresliNoticku(2*Skladba.Takt - DobaStara,Skladba.Noty[i], Pozice);
                        end;
                end;
        end;

end;

procedure TfrmSkladba.FormResize(Sender: TObject);
begin
        // upravi maximalni hodnotu posuvniku
        srlSkladba.Max := Skladba.PocetNot;
        // a prekresli notovou osnovu
        PrekresliNoticky;
end;

end.
